SystemOrganization addCategory: #'Pier-Security-Model'!
SystemOrganization addCategory: #'Pier-Security-Command'!
SystemOrganization addCategory: #'Pier-Security-Seaside'!

PRCommand subclass: #PRChangeSecurity
	instanceVariableNames: 'recursive operation commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

PRChangeSecurity subclass: #PRChangeGroup
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PRChangeGroup class methodsFor: 'accessing-description' stamp: 'lr 12/20/2005 15:45'!
descriptionGroup
	^ (MASingleOptionDescription selector: #group label: 'Group' priority: 200)
		options: (MADynamicObject on: [ PRCurrentContext value kernel groups ]);
		reference: PRGroup description;
		undefined: '(unchanged)';
		beSorted;
		yourself.! !

!PRChangeGroup class methodsFor: 'testing' stamp: 'lr 12/20/2005 09:35'!
isAbstract
	^ false! !

!PRChangeGroup class methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:34'!
label
	^ 'Change Group'! !

!PRChangeGroup methodsFor: 'configuration' stamp: 'lr 12/20/2005 16:02'!
commandAccessor
	^ MACascadeAccessor selectors: #( securityDecoration groupCommands ).! !

!PRChangeGroup methodsFor: 'events' stamp: 'lr 12/20/2005 15:53'!
doExecuteFor: aStructure
	self group notNil
		ifTrue: [ aStructure securityDecoration group: self group ].
	super doExecuteFor: aStructure.! !

!PRChangeGroup methodsFor: 'events' stamp: 'lr 12/20/2005 10:19'!
doInitialize
	super doInitialize.
	self group: self structure group.! !

!PRChangeGroup methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:39'!
group
	^ group! !

!PRChangeGroup methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:40'!
group: aGroup
	group := aGroup! !

PRChangeSecurity subclass: #PRChangeOther
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PRChangeOther class methodsFor: 'testing' stamp: 'lr 12/20/2005 10:33'!
isAbstract
	^ false! !

!PRChangeOther class methodsFor: 'accessing' stamp: 'lr 12/20/2005 10:32'!
label
	^ 'Change Other'! !

!PRChangeOther methodsFor: 'configuration' stamp: 'lr 12/20/2005 16:02'!
commandAccessor
	^ MACascadeAccessor selectors: #( securityDecoration otherCommands ).! !

PRChangeSecurity subclass: #PRChangeOwner
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PRChangeOwner class methodsFor: 'accessing-description' stamp: 'lr 12/20/2005 15:45'!
descriptionGroup
	^ (MASingleOptionDescription selector: #owner label: 'Owner' priority: 200)
		options: (MADynamicObject on: [ PRCurrentContext value kernel users ]);
		reference: PRUser description;
		undefined: '(unchanged)';
		beSorted;
		yourself.! !

!PRChangeOwner class methodsFor: 'testing' stamp: 'lr 12/20/2005 09:35'!
isAbstract
	^ false! !

!PRChangeOwner class methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:35'!
label
	^ 'Change Owner'! !

!PRChangeOwner methodsFor: 'configuration' stamp: 'lr 12/20/2005 16:02'!
commandAccessor
	^ MACascadeAccessor selectors: #( securityDecoration ownerCommands ).! !

!PRChangeOwner methodsFor: 'events' stamp: 'lr 12/20/2005 15:53'!
doExecuteFor: aStructure
	self owner notNil
		ifTrue: [ aStructure securityDecoration owner: self owner ].
	super doExecuteFor: aStructure.! !

!PRChangeOwner methodsFor: 'events' stamp: 'lr 12/20/2005 10:19'!
doInitialize
	super doInitialize.
	self owner: self structure owner.! !

!PRChangeOwner methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:41'!
owner
	^ owner! !

!PRChangeOwner methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:40'!
owner: anUser
	owner := anUser! !

!PRChangeSecurity class methodsFor: 'private' stamp: 'lr 12/20/2005 23:59'!
commandClasses
	^ PRCommand withAllConcreteClasses asSet
		remove: PRLogin;
		remove: PRLogout;
		yourself.! !

!PRChangeSecurity class methodsFor: 'accessing-description' stamp: 'lr 12/20/2005 23:58'!
descriptionCommands
	^ (MAMultipleOptionDescription selector: #commands label: 'Commands' priority: 400)
		options: (MADynamicObject on: [ self commandClasses ]);
		reference: MAClassDescription new;
		beSorted;
		yourself.! !

!PRChangeSecurity class methodsFor: 'accessing-description' stamp: 'lr 12/20/2005 15:57'!
descriptionOperation
	^ (MASingleOptionDescription selector: #operation label: 'Operation' priority: 300)
		reference: MASymbolDescription new;
		options: #( set add clear );
		undefined: '(unchanged)';
		yourself.! !

!PRChangeSecurity class methodsFor: 'accessing-description' stamp: 'lr 12/20/2005 10:33'!
descriptionRecursive
	^ (MABooleanDescription selector: #recursive label: 'Recursive' priority: 100)
		beRequired;
		yourself.! !

!PRChangeSecurity methodsFor: 'configuration' stamp: 'lr 12/20/2005 11:00'!
commandAccessor
	self subclassResponsability.! !

!PRChangeSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:05'!
commands
	^ commands! !

!PRChangeSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:33'!
commands: aCollectionOfCommands
	commands := aCollectionOfCommands asSet! !

!PRChangeSecurity methodsFor: 'events' stamp: 'lr 12/20/2005 10:40'!
doExecute
	super doExecute.
	self doExecuteFor: self structure.
	self recursive ifTrue: [
		self structure allChildrenDo: [ :each |
			self doExecuteFor: each ] ].! !

!PRChangeSecurity methodsFor: 'events' stamp: 'lr 12/20/2005 16:19'!
doExecuteFor: aStructure
	"Apply the changes to aStructure. Override this method and call super, it will be automatically called by #doExecute for all the requested structure."

	self commandAccessor 
		write: (self operation = #set 
			ifTrue: [ self commands copy ]
			ifFalse: [
				self operation = #add
					ifTrue: [ 
						(self commandAccessor read: aStructure) 
							copyWithAll: self commands ]
					ifFalse: [
						self operation = #clear
							ifTrue: [ 
								(self commandAccessor read: aStructure) 
									copyWithoutAll: self commands ]
							ifFalse: [ ^ self ] ] ])
		to: aStructure.! !

!PRChangeSecurity methodsFor: 'events' stamp: 'lr 12/20/2005 16:15'!
doInitialize
	super doInitialize.
	self recursive: true; operation: #set.
	self commands: (self commandAccessor 
		read: self structure).! !

!PRChangeSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 15:49'!
operation
	^ operation! !

!PRChangeSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 15:49'!
operation: aSymbol
	operation := aSymbol! !

!PRChangeSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:33'!
recursive
	^ recursive! !

!PRChangeSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:33'!
recursive: aBoolean
	recursive := aBoolean! !

PRCommand subclass: #PRLogin
	instanceVariableNames: 'username password user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PRLogin class methodsFor: 'accessing-description' stamp: 'lr 12/20/2005 11:44'!
descriptionPassword
	^ (MAPasswordDescription selector: #password label: 'Password' priority: 200)
		beRequired;
		yourself.! !

!PRLogin class methodsFor: 'accessing-description' stamp: 'lr 12/20/2005 11:44'!
descriptionUsername
	^ (MAStringDescription selector: #username label: 'Username' priority: 100)
		beRequired;
		yourself.! !

!PRLogin class methodsFor: 'testing' stamp: 'lr 12/20/2005 11:44'!
isAbstract
	^ false! !

!PRLogin class methodsFor: 'testing' stamp: 'lr 12/20/2005 14:14'!
isValidIn: aContext
	^  aContext isLoggedIn not.! !

!PRLogin class methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:44'!
label
	^ 'Login'! !

!PRLogin methodsFor: 'events' stamp: 'lr 12/20/2005 11:54'!
doAnswer
	super doAnswer.
	self answer setUser: self user.! !

!PRLogin methodsFor: 'events' stamp: 'lr 12/20/2005 11:45'!
doInitialize
	super doInitialize.
	self username: String new.
	self password: String new.! !

!PRLogin methodsFor: 'events' stamp: 'lr 12/20/2005 12:22'!
doValidate
	super doValidate.
	self user: (self kernel users
		detect: [ :each |
			each name = self username 
				and: [ each validatePassword: self password ] ]
		ifNone: [ PRInvalidLogin signal: 'Invalid username or password.' ]).! !

!PRLogin methodsFor: 'testing' stamp: 'lr 12/20/2005 11:54'!
isLogged
	^ false! !

!PRLogin methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:43'!
password
	^ password! !

!PRLogin methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:43'!
password: aString
	password := aString! !

!PRLogin methodsFor: 'private' stamp: 'lr 12/20/2005 11:53'!
user
	^ user! !

!PRLogin methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:43'!
username
	^ username! !

!PRLogin methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:43'!
username: aString
	username := aString! !

!PRLogin methodsFor: 'private' stamp: 'lr 12/20/2005 11:53'!
user: aUser
	user := aUser! !

PRCommand subclass: #PRLogout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Command'!

!PRLogout class methodsFor: 'testing' stamp: 'lr 12/20/2005 11:56'!
isAbstract
	^ false! !

!PRLogout class methodsFor: 'testing' stamp: 'lr 12/20/2005 14:15'!
isValidIn: aContext
	^  aContext isLoggedIn.! !

!PRLogout class methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:56'!
label
	^ 'Logout'! !

!PRLogout methodsFor: 'events' stamp: 'lr 12/20/2005 11:55'!
doAnswer
	super doAnswer.
	self answer setUser: nil.! !

!PRLogout methodsFor: 'testing' stamp: 'lr 12/20/2005 11:55'!
isLogged
	^ false! !

!PRLogout methodsFor: 'testing' stamp: 'lr 12/20/2005 12:13'!
isQuick
	^ true! !

PRStructuresWidget subclass: #PRRecentPagesWidget
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Seaside'!

!PRRecentPagesWidget class methodsFor: 'accessing-defaults' stamp: 'lr 12/20/2005 12:28'!
defaultCssClass
	^ 'box recent'! !

!PRRecentPagesWidget class methodsFor: 'accessing-defaults' stamp: 'lr 12/20/2005 12:30'!
defaultSize
	^ 10! !

!PRRecentPagesWidget class methodsFor: 'accessing-description' stamp: 'lr 12/20/2005 12:31'!
descriptionSize
	^ (MANumberDescription selector: #size label: 'Size' priority: 200 default: self defaultSize)
		addCondition: [ :value | value isInteger ] labelled: 'Invalid size.';
		beRequired;	
		yourself.! !

!PRRecentPagesWidget class methodsFor: 'testing' stamp: 'lr 12/20/2005 12:24'!
isAbstract
	^ false! !

!PRRecentPagesWidget class methodsFor: 'accessing' stamp: 'lr 12/20/2005 12:27'!
label
	^ 'Recent Pages'! !

!PRRecentPagesWidget methodsFor: 'testing' stamp: 'lr 12/20/2005 12:31'!
isVisible
	^ self context isLoggedIn.! !

!PRRecentPagesWidget methodsFor: 'accessing' stamp: 'lr 12/20/2005 12:30'!
size
	^ size! !

!PRRecentPagesWidget methodsFor: 'accessing' stamp: 'lr 12/20/2005 12:30'!
size: anInteger
	size := anInteger! !

PRDecoration subclass: #PRSecurity
	instanceVariableNames: 'owner ownerCommands group groupCommands otherCommands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

!PRSecurity commentStamp: 'lr 12/20/2005 15:05' prior: 0!
Every structure is owned by a specific user. The owner of an object comprises its user class. Permissions assigned to the user class only apply to that specific user. A structure is also assigned a group, which comprises its group class. Permissions assigned to the group class only apply to members of that group. Users who are not otherwise represented by the other two classes comprise a file's others class.

The effective permissions that have applied to a specific user in relation to a file are determined in logical precedence. For example, the user who owns the file will have the effective permissions given to the user class regardless of those assigned to the group or others class.!

!PRSecurity class methodsFor: 'testing' stamp: 'lr 12/20/2005 10:26'!
isAbstract
	^ false! !

!PRSecurity methodsFor: 'visiting' stamp: 'lr 12/20/2005 14:31'!
accept: aVisitor
	aVisitor visitSecurity: self.! !

!PRSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:30'!
group
	^ group! !

!PRSecurity methodsFor: 'accessing-permissions' stamp: 'lr 12/20/2005 10:56'!
groupCommands
	^ groupCommands! !

!PRSecurity methodsFor: 'accessing-permissions' stamp: 'lr 12/20/2005 10:56'!
groupCommands: aSet
	groupCommands := aSet! !

!PRSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 10:12'!
group: aGroup
	group := aGroup! !

!PRSecurity methodsFor: 'initialization' stamp: 'lr 12/20/2005 15:29'!
initialize
	super initialize.
	self ownerCommands: PRCommand withAllSubclasses asSet.
	self groupCommands: PRCommand withAllSubclasses asSet.
	self otherCommands: (Array with: PRViewCommand) asSet.! !

!PRSecurity methodsFor: 'testing' stamp: 'lr 12/20/2005 15:32'!
isValidCommand: aCommandClass in: aContext
	(self owner = aContext user)
		ifTrue: [ ^ self ownerCommands includes: aCommandClass ].
	(self group includes: aContext user)
		ifTrue: [ ^ self groupCommands includes: aCommandClass ].
	^ self otherCommands includes: aCommandClass.! !

!PRSecurity methodsFor: 'accessing-permissions' stamp: 'lr 12/20/2005 10:57'!
otherCommands
	^ otherCommands! !

!PRSecurity methodsFor: 'accessing-permissions' stamp: 'lr 12/20/2005 10:56'!
otherCommands: aSet
	otherCommands := aSet! !

!PRSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 15:04'!
owner
	^ owner! !

!PRSecurity methodsFor: 'accessing-permissions' stamp: 'lr 12/20/2005 15:04'!
ownerCommands
	^ ownerCommands! !

!PRSecurity methodsFor: 'accessing-permissions' stamp: 'lr 12/20/2005 15:04'!
ownerCommands: aSet
	ownerCommands := aSet! !

!PRSecurity methodsFor: 'accessing' stamp: 'lr 12/20/2005 15:04'!
owner: anUser
	owner := anUser! !

!PRSecurity methodsFor: 'copying' stamp: 'lr 12/20/2005 15:07'!
postCopy
	super postCopy.
	self ownerCommands: self ownerCommands copy.
	self groupCommands: self groupCommands copy.
	self otherCommands: self otherCommands copy.! !

!PRSecurity methodsFor: 'configuration' stamp: 'lr 12/20/2005 10:16'!
priority
	^ -200! !

PRWidget subclass: #PRSecurityWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Seaside'!

!PRSecurityWidget class methodsFor: 'accessing-defaults' stamp: 'lr 12/20/2005 12:28'!
defaultCssClass
	^ 'box security'! !

!PRSecurityWidget class methodsFor: 'testing' stamp: 'lr 12/20/2005 12:25'!
isAbstract
	^ false! !

!PRSecurityWidget class methodsFor: 'accessing' stamp: 'lr 12/20/2005 14:17'!
label
	^ 'Security'! !

!PRSecurityWidget methodsFor: 'rendering' stamp: 'lr 12/20/2005 12:55'!
renderContext: aDecoration on: html
	html 
		strong: 'Owner: ';
		render: aDecoration owner name;
		break.
	html 
		strong: 'Group: ';
		render: aDecoration group name;
		break.! !

!PRSecurityWidget methodsFor: 'rendering' stamp: 'lr 12/20/2005 12:53'!
renderUser: aUser on: html
	html 
		strong: 'User: ';
		render: aUser name;
		break.
	aUser groups notEmpty ifTrue: [
		html strong: 'Groups: '. 
		aUser groups 
			do: [ :each | html render: each name ]
			separatedBy: [ html text: '; ' ].
		html break ].! !

!PRSecurityWidget methodsFor: 'rendering' stamp: 'lr 12/20/2005 12:56'!
renderWidgetOn: html
	self context isLoggedIn
		ifTrue: [ self renderUser: self context user on: html. html break ].
	self renderContext: self context structure securityDecoration on: html.! !

!PRStructure class methodsFor: '*pier-security' stamp: 'lr 12/20/2005 10:31'!
descriptionGroup
	^ (MAOneToOneRelationDescription selector: #group label: 'Group' priority: 120)
		classes: (Array with: PRGroup);
		yourself.! !

!PRStructure class methodsFor: '*pier-security' stamp: 'lr 12/20/2005 10:31'!
descriptionOwner
	^ (MAOneToOneRelationDescription selector: #owner label: 'Owner' priority: 110)
		classes: (Array with: PRUser);
		yourself.! !

!PRStructure methodsFor: '*pier-security-accessing' stamp: 'lr 12/20/2005 14:05'!
group
	"Answer the owning-group of the file."

	^ self securityDecoration group.! !

!PRStructure methodsFor: '*pier-security-accessing' stamp: 'lr 12/20/2005 14:05'!
owner
	"Answer the owning-user of the receiver."
	
	^ self securityDecoration owner.! !

!PRStructure methodsFor: '*pier-security-decorations' stamp: 'lr 12/20/2005 15:28'!
securityDecoration
	^ self 
		decorationOfClass: self securityDecorationClass 
		ifAbsent: [ 
			self addDecoration: (self isRoot
				ifFalse: [ self parent securityDecoration copy ]
				ifTrue: [ 
					self securityDecorationClass new
						owner: self kernel users anyOne;
						group: self kernel groups anyOne;
						yourself ]) ].! !

!PRStructure methodsFor: '*pier-security-decorations' stamp: 'lr 12/20/2005 10:08'!
securityDecorationClass
	^ PRSecurity! !

!PRVisitor methodsFor: '*pier-security-visiting-structure' stamp: 'lr 12/20/2005 14:35'!
visitSecurity: anObject
	self visitDecoration: anObject! !

!PRContext methodsFor: '*pier-security-testing' stamp: 'lr 12/20/2005 12:32'!
isLoggedIn
	^ self user notNil.! !

!PRContext methodsFor: '*pier-security-initialization' stamp: 'lr 12/20/2005 12:16'!
setUser: aUser
	self propertyAt: #user put: aUser.! !

!PRContext methodsFor: '*pier-security-accessing' stamp: 'lr 12/20/2005 12:16'!
user
	^ self propertyAt: #user ifAbsentPut: [ nil ].! !

PRObject subclass: #PRMember
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

PRMember subclass: #PRGroup
	instanceVariableNames: 'users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

!PRGroup class methodsFor: 'testing' stamp: 'lr 12/20/2005 10:14'!
isAbstract
	^ false! !

!PRGroup methodsFor: 'testing' stamp: 'lr 12/20/2005 15:13'!
includes: anUser
	^ self users includes: anUser.! !

!PRGroup methodsFor: 'initialization' stamp: 'lr 12/20/2005 14:52'!
initialize
	super initialize.
	users := Set new.! !

!PRGroup methodsFor: 'accessing-readonly' stamp: 'lr 12/20/2005 14:51'!
users
	^ users! !

!PRMember class methodsFor: 'accessing-description' stamp: 'lr 12/20/2005 10:44'!
descriptionName
	^ (MAStringDescription selector: #name label: 'Name' priority: 100)
		beRequired;
		yourself.! !

!PRMember class methodsFor: 'instance-creation' stamp: 'lr 12/20/2005 10:13'!
named: aString
	^ self new
		name: aString;
		yourself.! !

!PRMember methodsFor: 'accessing' stamp: 'lr 12/20/2005 10:13'!
name
	^ name! !

!PRMember methodsFor: 'accessing' stamp: 'lr 12/20/2005 14:51'!
name: aString
	name := aString! !

!PRMember methodsFor: 'printing' stamp: 'lr 12/20/2005 10:14'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' name: '; print: self name.! !

PRMember subclass: #PRUser
	instanceVariableNames: 'password groups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!

!PRUser class methodsFor: 'testing' stamp: 'lr 12/20/2005 10:14'!
isAbstract
	^ false! !

!PRUser methodsFor: 'utilties' stamp: 'lr 12/20/2005 14:53'!
addGroup: aGroup
	self groups add: aGroup.
	aGroup users add: self.! !

!PRUser methodsFor: 'accessing-readonly' stamp: 'lr 12/20/2005 12:52'!
groups
	^ groups! !

!PRUser methodsFor: 'initialization' stamp: 'lr 12/20/2005 14:52'!
initialize
	super initialize.
	groups := Set new.! !

!PRUser methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:35'!
password
	^ String new: 10 withAll: $*.! !

!PRUser methodsFor: 'accessing' stamp: 'lr 12/20/2005 11:39'!
password: aString
	password := PRCompatibility hashPassword: aString.! !

!PRUser methodsFor: 'utilties' stamp: 'lr 12/20/2005 14:53'!
removeGroup: aGroup
	self groups remove: aGroup.
	aGroup users remove: self.! !

!PRUser methodsFor: 'validating' stamp: 'lr 12/20/2005 12:22'!
validatePassword: aString
	^ aString isEmptyOrNil not
		and: [ (PRCompatibility hashPassword: aString) = password ].! !

!PRKernel methodsFor: '*pier-security-accessing' stamp: 'lr 12/20/2005 14:50'!
groups
	^ self 
		propertyAt: #groups
		ifAbsentPut: [ 
			Set with: (PRGroup new
				name: 'root';
				yourself) ].! !

!PRKernel methodsFor: '*pier-security-accessing' stamp: 'lr 12/20/2005 16:09'!
users
	^ self 
		propertyAt: #users 
		ifAbsentPut: [ 
			Set with: (PRUser new
				name: 'admin'; password: 'pier';
				addGroup: self groups anyOne;
				yourself) ].! !

MAError subclass: #PRInvalidLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Security-Model'!
